//
//  DNAbstractRule.h
//  dXml
//
//  Created by Derek Clarkson on 27/01/10.
//  Copyright 2010 Derek Clarkson. All rights reserved.
//

#import <dNodi/DNNode.h>
#import <dNodi/DNSelector.h>

typedef void(^NodeProcessingBlock)(id obj, NSUInteger idx, BOOL *stop, NSMutableArray *returnNodes);

/**
 Abstract parent class of all selectors. The basic idea of a selector is that it is presented with a node and asked to select further nodes based on that node. For example a parent node select is given a node and returns it's parent.
 */
@interface DNAbstractSelector : NSObject<DNSelector>

/// @name Overridable Tasks

/**
 Process the passed node and returns a list of new nodes.

 The nodes returned from this method are then passed to the next selector as it's input. If nil is returned, the selector chain ends. The default implementation of this method returns the node passed to it. This will result in processNodes: returning the same nodes it was passed, except that they will be in a new NSArray object.

 @param node the node to check.
 @param 
 @return a NSArray of nodes. If empty, no nodes where selected.
 */
-(NSArray *) processNode:(id<DNNode>) node index:(NSUInteger) index;


@end
