//
//  DNAbstractRule.m
//  dXml
//
//  Created by Derek Clarkson on 27/01/10.
//  Copyright 2010 Derek Clarkson. All rights reserved.
//

#import <dNodi/DNAbstractSelector.h>
#import <dUsefulStuff/DCCommon.h>

@implementation DNAbstractSelector

@synthesize nextSelector = _nextSelector;

- (void) dealloc {
	self.nextSelector = nil;
	[super dealloc];
}

-(NSArray *) executeWithNodes:(NSArray *)nodes {

	NSMutableArray *finalNodes = [NSMutableArray array];
	
	// Run the nodes through this selector to generate a new list.
	[nodes enumerateObjectsUsingBlock:^(id obj, NSUInteger idx, BOOL *stop) {
		NSArray *newNodes = [self processNode:obj index:idx];
		if (newNodes != nil && [newNodes count] > 0) {
			[finalNodes addObjectsFromArray:newNodes];
		}
	}];

	// If there is another selector in the chain pass the new list and get back it's results.
	return self.nextSelector == nil ? finalNodes : [self.nextSelector executeWithNodes:finalNodes];
}

-(NSArray *) processNode:(id<DNNode>) node index:(NSUInteger) index {
	DC_LOG(@"Returning same node: %@", node.dnName);
	return @[node];
}

@end
