//
//  DNAttributeSelector.m
//  dNodi
//
//  Created by Derek Clarkson on 29/07/11.
//  Copyright 2011. All rights reserved.
//

#import <dNodi/DNAttributeSelector.h>
#import <dUsefulStuff/DCCommon.h>

@interface DNAttributeSelector () {
@private
	NSString *_attributeName;
	NSString *_value;
}
@end

@implementation DNAttributeSelector

@synthesize attributeName = _attributeName;
@synthesize value = _value;

-(void) dealloc {
	DC_DEALLOC(_attributeName);
	DC_DEALLOC(_value);
	[super dealloc];
}

- (id) initWithAttributeName:(NSString *)attributeName value:(NSString *) value {
	self = [super init];
	if (self) {
		_attributeName = [attributeName retain];
		_value = [value retain];
	}
	
	return self;
}

-(NSArray *) processNode:(id<DNNode>)node index:(NSUInteger)index {
	DC_LOG(@"Checking node %@ for attribute \"%@\"=\"%@\"", node.dnName, _attributeName, _value);
	if ([node dnHasAttribute:_attributeName withValue:_value]) {
		DC_LOG(@"Success");
		return @[node];
	}
	return nil;
}

@end
