
/**
 Lists all the error codes that dNodi can return.
 */
typedef enum {
	DNErrorInvalidNodiExpression = 1
} DNError;

#define DN_ERROR_DOMAIN @"DNError"

// This enums tells us the types of the tokens being read that can be read.
typedef enum {
	DNTokenStart = 0,
	DNTokenSlash,
	DNTokenNodeName,
	DNTokenOpenBracket,
	DNTokenCloseBracket,
	DNTokenNumber,
	DNTokenSubtree,
	DNTokenParent,
	DNTokenEnd,
	DNTokenAttributeName,
	DNTokenEquals,
	DNTokenOpenQuote,
	DNTokenValue,
	DNTokenCloseQuote,
   DNTokenComma,
   DNTokenProperty,
	DNTokenError
} DNToken;

// Array of names for the tokens. Used in error messages.
#define tokenDescriptions @[ \
	@"Start", \
	@"Slash", \
	@"Node name", \
	@"'['", \
	@"']'", \
	@"Number", \
	@"//", \
	@"/..", \
	@"End", \
	@"Attribute name", \
	@"'='", \
	@"Opening ' or \"", \
	@"Value", \
	@"Closing ' or \"", \
   @"','", \
   @"'.'", \
	@"Error"]
