//
//  DNExcutor.m
//  dXml
//
//  Created by Derek Clarkson on 24/01/10.
//  Copyright 2010 Derek Clarkson. All rights reserved.
//

#import <dUsefulStuff/DCCommon.h>

#import <dNodi/DNExecutor.h>
#import <dNodi/DNSelector.h>
#import <dNodi/DNParser.h>

@implementation DNExecutor

@synthesize rootNode;

- (DNExecutor *) initWithRootNode:(NSObject<DNNode> *)aRootNode {
	self = [super init];
	if (self) {
		self.rootNode = aRootNode;
	}
	return self;
}

- (NSArray *) executeQuery:(NSString *)query error:(NSError **)error {

	DC_LOG(@"Processing query: %@", query);

	DNParser *parser = [[[DNParser alloc] init] autorelease];
	id<DNSelector> selector = [parser selectorChainForQuery:query error:error];

	if (selector == nil) {
		// There's an error.
		return nil;
	}

	return [selector executeWithNodes:@[self.rootNode]];

}

@end