//
//  DNNodeRule.h
//  dXml
//
//  Created by Derek Clarkson on 26/01/10.
//  Copyright 2010 Derek Clarkson. All rights reserved.
//

#import <dNodi/DNAbstractSelector.h>
/**
 Selects a subnode based on it's name.
 */
@interface DNNodeNameSelector : DNAbstractSelector

/// @name Properties

/// Mainly used for testing
@property (nonatomic, readonly) NSString *nodeName;

/// @name Initialisation

/**
 Main initialiser.
 
 @param nodeName the name we are looking for.
 @param error an error variable that is populated if aNodeName contains a '*' character and the regular expression has a problem.
 @return an instance of this class or nil if there was an error. Then see the error variable for the error messages.
 */
- (id) initWithNodeName:(NSString *)nodeName error:(NSError **)error;

@end
