//
//  DNScanner.h
//  dNodi
//
//  Created by Derek Clarkson on 23/11/12.
//
//

#import <dNodi/DNScannerDelegate.h>

/**
 Does the grunt work of processing the xpath text.
 
 This is started by calling the scanPath:error method. This reads the text and emits tokens and values through the methods on DNScannerDelegate.
 
 */
@interface DNScanner : NSObject

/// @name Initialisers

/**
Default initialiser that takes a delegate.
 
 @param delegate an object that can accept a stream of tokens from this scanner.
 @result an instance of this class.
 */
-(id) initWithDelegate:(id<DNScannerDelegate>) delegate;

/**
 Initates the scanning of the passed path.
 
 @param path the text containing a path to be processed.
 @param error a reference to a NSError variable.
 @retunr YES if the scan was successful and a tokens where emitted. NO if an error has occured.
 */
-(BOOL) scanPath:(NSString *) path error:(NSError **) error;

@end
