//
//  AbstractTestBase.m
//  dNodi
//
//  Created by Derek Clarkson on 7/18/11.
//  Copyright 2011. All rights reserved.
//

#import "AbstractTestBase.h"
#import <dUsefulStuff/DCCommon.h>

@implementation AbstractTestBase

-(void) setUp {
	// Create a data structure for tests:
	// abc
	//    def[xyz='xxx',zyx='yyy']
	//       ghi
	//    def
	//       lmn
	//    opq[abc.def='qqq']
	//    opz
	//    zpq
	//    ozq
	abc = [[DummyNode alloc] initWithParent:nil name:@"abc"];
	
	def0 = [[abc addSubNode:@"def"] retain];
	[def0 setAttribute:@"xyz" value:@"xxx"];
	[def0 setAttribute:@"zyx" value:@"yyy"];
	ghi = [[def0 addSubNode:@"ghi"] retain];

	def1 = [[abc addSubNode:@"def"] retain];
	lmn = [[def1 addSubNode:@"lmn"] retain];
	
	opq = [[abc addSubNode:@"opq"] retain];
	[opq setAttribute:@"abc.def" value:@"qqq"];
	opz = [[abc addSubNode:@"opz"] retain];
	zpq = [[abc addSubNode:@"zpq"] retain];
	ozq = [[abc addSubNode:@"ozq"] retain];
	
	error = NULL;
}

-(void) tearDown {
	DC_DEALLOC(abc);
	DC_DEALLOC(def0);
	DC_DEALLOC(def1);
	DC_DEALLOC(ghi);
	DC_DEALLOC(lmn);
	DC_DEALLOC(opq);
	DC_DEALLOC(opz);
	DC_DEALLOC(zpq);
	DC_DEALLOC(ozq);
}

@end
