//
//  DNabstractSelectorTests.m
//  dXml
//
//  Created by Derek Clarkson on 31/01/10.
//  Copyright 2010 Derek Clarkson. All rights reserved.
//
#import <GHUnitIOS/GHUnit.h>
#import <OCMock/OCMock.h>
#import <dUsefulStuff/DCCommon.h>

#import <Foundation/Foundation.h>
#import <dNodi/DNAbstractSelector.h>
#import "AbstractTestBase.h"




@interface DNAbstractSelectorTests : AbstractTestBase
@end

@implementation DNAbstractSelectorTests

-(void) testReturnsPassedListOfNodesWhenNoNextSelector {
	DNAbstractSelector *selector = [[[DNAbstractSelector alloc] init] autorelease];
	NSArray *returnArray = [selector executeWithNodes:abc.dnSubNodes];
	GHAssertEqualObjects(returnArray, abc.dnSubNodes, nil);
}

-(void) testPassesEachNodeToNextSelector {

	id mockNextSelector = [OCMockObject mockForProtocol:@protocol(DNSelector)];
		[[[mockNextSelector expect] andReturn:@[abc]] executeWithNodes:@[abc]];
	
	DNAbstractSelector *selector = [[[DNAbstractSelector alloc] init] autorelease];
	selector.nextSelector = mockNextSelector;
	
		 NSArray *returnNodes = [selector executeWithNodes:@[abc]];
	GHAssertEqualObjects(returnNodes, @[abc], nil);

	[mockNextSelector verify];
}


@end

