//
//  DNRootNodeRuleTests.m
//  dXml
//
//  Created by Derek Clarkson on 25/01/10.
//  Copyright 2010 Derek Clarkson. All rights reserved.
//
#import <GHUnitIOS/GHUnit.h>

#import "AbstractTestBase.h"
#import <dNodi/DNParentSelector.h>
#import <dNodi/DNSelector.h>
#import "DummyNode.h"

@interface DNParentSelectorTests : AbstractTestBase
@end

@implementation DNParentSelectorTests

- (void) testReturnsParentNode {
	id<DNSelector> selector = [[[DNParentSelector alloc] init] autorelease];
	NSArray *nodes = [selector executeWithNodes:@[def1]];
	GHAssertEquals([nodes count], (NSUInteger) 1, nil);
	GHAssertEqualStrings(((DummyNode *)nodes[0]).dnName, @"abc", nil);
}

- (void) testReturnsNothingWhenAtRoot {
	id<DNSelector> selector = [[[DNParentSelector alloc] init] autorelease];
	NSArray *nodes = [selector executeWithNodes:@[abc]];
	GHAssertEquals([nodes count], (NSUInteger) 0, nil);
}

@end
