//
//  DummyNode.m
//  dNodi
//
//  Created by Derek Clarkson on 30/07/11.
//  Copyright 2011. All rights reserved.
//

#import "DummyNode.h"
#import <dUsefulStuff/DCCommon.h>

@implementation DummyNode

@synthesize dnName = _dnName;
@synthesize dnParentNode = _dnParentNode;
@synthesize dnSubNodes = _dnSubNodes;

-(void) dealloc {
	DC_DEALLOC(_dnName);
	DC_DEALLOC(_dnSubNodes);
	DC_DEALLOC(attributes);
	[super dealloc];
}

-(BOOL) dnHasAttribute:(NSString *) attribute withValue:(NSString *) value {
	return [[attributes objectForKey:attribute] isEqual:value];
}

-(id) initWithParent:(DummyNode *) theParent name:(NSString *) aName {
	self = [super init];
	if (self) {
		_dnName = aName;
		_dnParentNode = theParent; // Weak reference please.
		_dnSubNodes = [[NSMutableArray alloc] init];
		attributes = [[NSMutableDictionary alloc] init];
	}
	return self;
}

-(DummyNode *) addSubNode:(NSString *) aName {
	DummyNode *node = [[[DummyNode alloc] initWithParent:self name:aName] autorelease];
	[(NSMutableArray *)self.dnSubNodes addObject:node];
	return node;
}

-(void) setAttribute:(NSString *) attribute value:(NSString *) value {
	[attributes setObject:value forKey:attribute];	
}

-(NSString *) description {
	NSMutableString *description = [NSMutableString stringWithString:self.dnName];
	if ([attributes count] > 0) {
		[description appendString:@"["];
		__block BOOL first = YES;
		[attributes enumerateKeysAndObjectsUsingBlock:^(id key, id value, BOOL *stop) {
			if (!first) {
				[description appendString:@","];
			}
			[description appendString:[NSString stringWithFormat:@"%@='%@'", key, value]];
			first = NO;
		}];
		[description appendString:@"]"];
	}
	return description;
}

@end
